<?php
$k = 3; //# of clusters
$data = array(array(1,0), array(2,0), array(10,0), array(11,0), array(15,1), array(20,5)); //data to cluster

print("Data :<br/>");
for($i=0;$i<count($data);$i++){
	$name = "Recipe ".($i+1);
	$data_names[$i] = $name;
	print($name ." : (");
	for($j=0;$j<count($data[$i]);$j++){
		if($j!= (count($data[$i])-1))
			print($data[$i][$j].",");
		else
			print($data[$i][$j].")");
	}
	print("<br/>");
	}
print("<br/>");

$result = kMeans($data, $k);
$centroids = $result['centroids'];
$clusters = $result['mapping'];

print("Centroids :<br/>");
for($i=0;$i<count($centroids);$i++){
	print("Centroid ".($i+1)." : (");
	for($j=0;$j<count($centroids[$i]);$j++){
		if($j!= (count($centroids[$i])-1))
			print($centroids[$i][$j].",");
		else
			print($centroids[$i][$j].")");
	}
	print("<br/>");
	}
print("<br/>");	
print("Clusters :<br/>");
for($k=0;$k<count($clusters);$k++){
	print("Cluster ".($k+1).": {");
	for($j=0;$j<count($clusters[$k]);$j++){
		$temp = $clusters[$k][$j];
		print($data_names[$temp]);
		print("(");
		for($i=0;$i<count($data[$temp]);$i++){
			if($i != (count($data[$temp])-1))
				print($data[$temp][$i].",");
			else
				print($data[$temp][$i]);
		}
		if($j != (count($clusters[$k])-1))
			print("), ");
		else
			print(")");
		
	}
	print("}<br/>");
}

/*function to perform KMeans clustering. SetCentroids selects random points as centroids.
groupPoints set the points around the centroids, updateCentroids updates the centroids.*/

function kMeans($data, $k) {
	$centroids = setCentroids($data, $k);
	$mapping = array();
	$changed = true;
	while($changed) {
		$new_mapping = groupPoints($data, $centroids);
		if($new_mapping != $mapping) {
			$mapping = $new_mapping;
			$changed = true;
			$centroids  = updateCentroids($mapping, $data, $k); 
		}
		else
			$changed = false;
	}
	$result['centroids'] = $centroids;
	$result['mapping'] = $mapping;
	return $result;	
	}

function setCentroids(array $data, $k) {
	$centroids = array();
	for($i=0;$i<$k;$i++)
		$centroids[$i] =  $data[rand(0, (count($data)-1))];
	return $centroids;
}

function groupPoints($data, $centroids) {
	$mapping = array();
	$dist = 0;
	foreach($data as $id=>$point){
		$close_centroid = null;
		$min_dist =100;
		for($i=0; $i<count($centroids);$i++){
			$dist = 0;
			for($j=0;$j<count($point);$j++){
				$dist += ($point[$j]-$centroids[$i][$j])*($point[$j]-$centroids[$i][$j]);
			}
			
			$final_dist= sqrt($dist);
			if($min_dist > $final_dist){
				$min_dist = $final_dist;
				$close_centroid = $i;
			}
		}
		$mapping[$close_centroid][] = $id;
	}
	return $mapping;
}

function updateCentroids($mapping, $data, $k) {
	$centroids = array();
	foreach($mapping as $id=>$centroid){
		foreach($centroid as $point){
			for($i=0;$i<count($data[$point]);$i++)
				$centroids[$id][$i] += $data[$point][$i]/count($centroid);
		}
	}	
	if(count($centroids) < $k) {
		$centroids = array_merge($centroids, setCentroids($data, $k - count($centroids)));
	}
	return $centroids;
}
?>
